Bug 1030751 - Review Request: python-bbcode - A pure python bbcode parser and formatter [NEEDINFO]
Review Request: python-bbcode - A pure python bbcode parser and formatter
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Pete Travis
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1010741
  Show dependency treegraph
 
Reported: 2013-11-14 23:27 EST by Christopher Meng
Modified: 2016-09-26 11:30 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
cstratak: needinfo? (i)


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2013-11-14 23:27:21 EST
Spec URL: http://cicku.me/python-bbcode.spec
SRPM URL: http://cicku.me/python-bbcode-1.0.12-1.fc21.src.rpm
Description: This is a Python library for parsing and formatting Bulletin Board Code.
Fedora Account System Username: cicku
Comment 1 Pete Travis 2013-11-15 01:09:53 EST
Something's gone wrong with the SRPM! try another upload?
Comment 2 Christopher Meng 2013-11-15 01:49:51 EST
(In reply to Pete Travis from comment #1)
> Something's gone wrong with the SRPM! try another upload?

You can try again at the same URLs now.

My internet connection is fuzzy now...(saw your email for already 30 mins but just can open this page.)
Comment 3 Pete Travis 2013-11-22 12:20:31 EST
There's no documentation or license included in the tarball or package. Have you brought this concern upstream?
Comment 4 Christopher Meng 2013-11-25 21:25:14 EST
I've contacted upstream and they released a new tarball on pypi with license included.

Spec URL: http://cicku.me/python-bbcode.spec
SRPM URL: http://cicku.me/python-bbcode-1.0.13-1.fc21.src.rpm
Comment 5 Pete Travis 2014-01-26 18:02:07 EST
This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 4 files have unknown license. Detailed output of
     licensecheck in /home/pete/rpmbuild/1030751-python-
     bbcode/licensecheck.txt
[ ]: License file installed when any subpackage combination is installed.
[ ]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/python3.3/site-
     packages/__pycache__(python3-setuptools, python3-libs)
[ ]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory names).
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[ ]: Python eggs must not download any dependencies during the build process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-bbcode
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-bbcode-1.0.13-1.fc20.noarch.rpm
          python3-bbcode-1.0.13-1.fc20.noarch.rpm
          python-bbcode-1.0.13-1.fc20.src.rpm
python-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python-bbcode.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/bbcode.py 0644L /usr/bin/env
python3-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python3-bbcode.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/bbcode.py 0644L /usr/bin/env
python-bbcode.src: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
3 packages and 0 specfiles checked; 2 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-bbcode python3-bbcode
python-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python-bbcode.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/bbcode.py 0644L /usr/bin/env
python3-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python3-bbcode.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/bbcode.py 0644L /usr/bin/env
2 packages and 0 specfiles checked; 2 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-bbcode (rpmlib, GLIBC filtered):
    python(abi)

python3-bbcode (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python-bbcode:
    python-bbcode

python3-bbcode:
    python3-bbcode



Source checksums
----------------
https://pypi.python.org/packages/source/b/bbcode/bbcode-1.0.13.tar.gz :
  CHECKSUM(SHA256) this package     : d47be2eb46e039cedd7eb2b542a18cf132010389e314a3359dc0d9517259601e
  CHECKSUM(SHA256) upstream package : d47be2eb46e039cedd7eb2b542a18cf132010389e314a3359dc0d9517259601e


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1030751
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 6 Pete Travis 2014-01-26 18:02:26 EST
Hey Christopher, sorry this dropped off my radar for a while.

You could probably strip the shebang from bbcode.py; not a blocker, but `rpmlint` complains.

Other than that, it looks like you've put together a compliant, sane package.

APPROVED
Comment 7 Michael Schwendt 2014-01-26 18:27:01 EST
Which of the many '[ ]' items on that list have been reviewed manually as per the instructions?
Comment 8 Pete Travis 2014-01-26 20:38:31 EST
(In reply to Michael Schwendt from comment #7)
> Which of the many '[ ]' items on that list have been reviewed manually as
> per the instructions?

I did review them, sorry about that. Will post a more comprehensive review soon.
Comment 9 Pete Travis 2014-01-27 02:11:32 EST
Another pass; with manually reviewed sections noted and xclip output trimmed :)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
    -- BSD License confirmed via upstream github and included license file.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 4 files have unknown license. Detailed output of
     licensecheck in /home/pete/rpmbuild/1030751-python-
     bbcode/licensecheck.txt
    -- Package spec lists BSD License
[-]: License file installed when any subpackage combination is installed.
    -- Licence in subpackage - check!
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/python3.3/site-
     packages/__pycache__(python3-setuptools, python3-libs)
     -- Owns it's own files in cited directories,
[x]: Package contains no bundled libraries without FPC exception.
    -- No bundled libs
[x]: Changelog in prescribed format.
    -- Correct format!
[x]: Sources contain only permissible code or content.
    -- All BSD!
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
    -- docs only!
[x]: Package consistently uses macros (instead of hard-coded directory names).
    -- Good macro coverage.
[x]: Package is named according to the Package Naming Guidelines.
    -- Good name.
[x]: Package does not generate any conflict.
    -- No conflicts
[x]: Package obeys FHS, except libexecdir and /usr/target.
    Python stuff in site-packages, doc in %doc, no complaints.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
    -- Requires not declared, python require inherent.
[x]: Spec file is legible and written in American English.
    -- Understandable spec file, check.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
    -- No faults observed.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
   -- egginfo present!
[x]: Package meets the Packaging Guidelines::Python
   -- Loosk good!
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-bbcode
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
  -- No checks, but included files do function.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-bbcode-1.0.13-1.fc20.noarch.rpm
          python3-bbcode-1.0.13-1.fc20.noarch.rpm
          python-bbcode-1.0.13-1.fc20.src.rpm
python-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python-bbcode.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/bbcode.py 0644L /usr/bin/env
python3-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python3-bbcode.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/bbcode.py 0644L /usr/bin/env
python-bbcode.src: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
3 packages and 0 specfiles checked; 2 errors, 3 warnings.

-- Spelling is a non-issue here; removing shebang will remove error.


Rpmlint (installed packages)
----------------------------
# rpmlint python-bbcode python3-bbcode
python-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python-bbcode.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/bbcode.py 0644L /usr/bin/env
python3-bbcode.noarch: W: spelling-error Summary(en_US) formatter -> formatted, for matter, for-matter
python3-bbcode.noarch: E: non-executable-script /usr/lib/python3.3/site-packages/bbcode.py 0644L /usr/bin/env
2 packages and 0 specfiles checked; 2 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-bbcode (rpmlib, GLIBC filtered):
    python(abi)

python3-bbcode (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python-bbcode:
    python-bbcode

python3-bbcode:
    python3-bbcode



Source checksums
----------------
https://pypi.python.org/packages/source/b/bbcode/bbcode-1.0.13.tar.gz :
  CHECKSUM(SHA256) this package     : d47be2eb46e039cedd7eb2b542a18cf132010389e314a3359dc0d9517259601e
  CHECKSUM(SHA256) upstream package : d47be2eb46e039cedd7eb2b542a18cf132010389e314a3359dc0d9517259601e


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1030751
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 10 Michael Schwendt 2014-01-27 05:59:15 EST
Great!

> [x]: Package does not own files or directories owned by other packages.
>      Note: Dirs in package are owned also by: /usr/lib/python3.3/site-
>      packages/__pycache__(python3-setuptools, python3-libs)

What this item on the list means is: The fedora-review tool found directories in the package, which are owned by other packages already. That refers to the following part of the guidelines:

  https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_also_owned_by_a_package_implementing_required_functionality_of_your_package

>      -- Owns it's own files in cited directories,

It should _not_ own /usr/lib/python3.3/site-packages/__pycache__ because that one belongs into python3-libs already.

Co-ownership of directories can become a problem, if one package messes up the file access permissions, for example. That's why the guidelines still try to reduce co-ownership to the exceptional cases: https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function

[...]

Not related to the Review Guidelines, but to: 
https://fedoraproject.org/wiki/Examples_of_good_package_summaries

> Summary:        A pure python bbcode parser and formatter

My alternative suggestion that also eliminates the lower-case spelling of everything:

  Summary: BBCode parser and formatter written in Python
Comment 11 Pete Travis 2014-01-27 08:44:10 EST
(In reply to Michael Schwendt from comment #10)
> Great!

Thanks, Michael. I appreciate you taking the time to help me understand this.

> 
> > [x]: Package does not own files or directories owned by other packages.
> >      Note: Dirs in package are owned also by: /usr/lib/python3.3/site-
> >      packages/__pycache__(python3-setuptools, python3-libs)
> 
> What this item on the list means is: The fedora-review tool found
> directories in the package, which are owned by other packages already. That
> refers to the following part of the guidelines:
> 
>  
> https://fedoraproject.org/wiki/Packaging:
> Guidelines#The_directory_is_also_owned_by_a_package_implementing_required_fun
> ctionality_of_your_package
> 
> >      -- Owns it's own files in cited directories,
> 
> It should _not_ own /usr/lib/python3.3/site-packages/__pycache__ because
> that one belongs into python3-libs already.
> 
> Co-ownership of directories can become a problem, if one package messes up
> the file access permissions, for example. That's why the guidelines still
> try to reduce co-ownership to the exceptional cases:
> https://fedoraproject.org/wiki/Packaging:
> Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your
> _package_to_function

My thinking here was that the "__pycache__"" directory wasn't present in the source tarball, and was claimed via the "%{python3_sitelib}/*" glob, so it was a result of the build process and safe to glob, similar to the py2 glob that didn't throw a warning or even pyc,pyo files that aren't shipped but generated. I'll read up on this, and certainly remember it.

Christopher, please adjust for this.

> 
> [...]
> 
> Not related to the Review Guidelines, but to: 
> https://fedoraproject.org/wiki/Examples_of_good_package_summaries
> 
> > Summary:        A pure python bbcode parser and formatter
> 
> My alternative suggestion that also eliminates the lower-case spelling of
> everything:
> 
>   Summary: BBCode parser and formatter written in Python

I prefer your suggestion too, but the existing summary matches upstream.
Comment 12 Charalampos Stratakis 2016-09-26 11:30:33 EDT
Project is still active upstream:
https://github.com/dcwatson/bbcode

Is there still a desire to package it for fedora?

Note You need to log in before you can comment on or make changes to this bug.